/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Delaunay.xs. Do not edit this file, edit Delaunay.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Math/Geometry/Delaunay.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <string.h>

/* cross-platform macros to set floating point precision for doubles */
/* Mainly needed to restore defaults, since Triangle doesn't.        */
/* http://www.christian-seiler.de/projekte/fpmath/                   */

#include "xpfpa.h"

/* triangle.h needs these two defines                 */
/* REAL can be single or double, but I've used        */
/* double everywhere in the code here, so use double. */
/* TRIVOID should be void. triangle.c sets it to int  */
/* to "fool dumb compilers" but void looks like it's  */
/* more portable.                                     */
/* We also set REAL in the Build.PL compiler flags.   */
/* NOTE: TRIVOID should also be defined as void       */
/* (instead of int) directly in triangle.c.           */
/* NOTE: TRIVOID was originally VOID in triangle.c,   */
/* but that interacted in a bad way with VOID defined */
/* in winnt.h in MingW, so: triangle.c =~ s/VOID/TRIVOID/g */

#define REAL double
#define TRIVOID void
typedef REAL *vertex;

#include "triangle.h"

/* declare a couple functions in triangle.c not exposed by triangle.h */
/* mainly to supress compiler warnings */

#ifdef ANSI_DECLARATORS
REAL counterclockwiseadapt(vertex pa, vertex pb, vertex pc, REAL detsum);
void exactinit();
#else /* not ANSI_DECLARATORS */
void counterclockwiseadapt();
void exactinit();
#endif /* not ANSI_DECLARATORS */

/* these let us refer to the struct in triangle.h */

typedef struct triangulateio * Math__Geometry__Delaunay__TriangulateioPtr;
typedef struct triangulateio   Math__Geometry__Delaunay__Triangulateio;

/* for T_ARRAY typmap */

typedef double doubleArray;
typedef int       intArray;

/* for our custom T_ARRAY input code */

#define doubleArrayPtrContains double
#define intArrayPtrContains    int

/* memory allocation functions for T_ARRAY typemap INPUT */

doubleArray * doubleArrayPtr( int nelem ) {
    doubleArray * array;
    array = (doubleArray *) trimalloc(nelem * sizeof(double));
    return array;
    }
intArray * intArrayPtr( int nelem ) {
    intArray * array;
    array = (intArray *) trimalloc(nelem * sizeof(int));
    return array;
    }

/* ccw test with adaptive exact fallback, adapted from        */
/* Triangle's version (removed mesh and behavior params)      */
/* "The result is also a rough approximation of twice the     */
/*  signed area of the triangle defined by the three points." */

/* A global defined in triangle.c */
extern REAL ccwerrboundA;

double mgdcounterclockwise(vertex pa, vertex pb, vertex pc) {
  REAL detleft, detright, det;
  REAL detsum, errbound;
  XPFPA_DECLARE()

  detleft = (pa[0] - pc[0]) * (pb[1] - pc[1]);
  detright = (pa[1] - pc[1]) * (pb[0] - pc[0]);
  det = detleft - detright;

  if (detleft > 0.0) {
    if (detright <= 0.0) {
      return det;
    } else {
      detsum = detleft + detright;
    }
  } else if (detleft < 0.0) {
    if (detright >= 0.0) {
      return det;
    } else {
      detsum = -detleft - detright;
    }
  } else {
    return det;
  }

  errbound = ccwerrboundA * detsum;
  if ((det >= errbound) || (-det >= errbound)) {
    return det;
  }

  XPFPA_SWITCH_DOUBLE()
  det = counterclockwiseadapt(pa, pb, pc, detsum);
  XPFPA_RESTORE()

  return det;
}


/* TODO: */
/* Consider offering the -u option, the "user defined constraint" function feature.   */
/* Define a C function that calls a Perl function stub to be overidden. See perlcall. */


#line 134 "lib/Math/Geometry/Delaunay.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 278 "lib/Math/Geometry/Delaunay.c"

XS_EUPXS(XS_Math__Geometry__Delaunay_exactinit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Geometry__Delaunay_exactinit)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 130 "lib/Math/Geometry/Delaunay.xs"
      XPFPA_DECLARE() /* declares vars to stash the floating point config */
#line 289 "lib/Math/Geometry/Delaunay.c"
	SV *	RETVAL;
#line 132 "lib/Math/Geometry/Delaunay.xs"
      XPFPA_SWITCH_DOUBLE()
      exactinit();
      XPFPA_RESTORE()
#line 295 "lib/Math/Geometry/Delaunay.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Geometry__Delaunay__triangulate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Geometry__Delaunay__triangulate)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "arg0, arg1, arg2, arg3");
    {
	char *	arg0 = (char *)SvPV_nolen(ST(0))
;
	Math__Geometry__Delaunay__TriangulateioPtr	arg1;
	Math__Geometry__Delaunay__TriangulateioPtr	arg2;
	Math__Geometry__Delaunay__TriangulateioPtr	arg3;
#line 143 "lib/Math/Geometry/Delaunay.xs"
      char * doVoronoi = 0;
      XPFPA_DECLARE() /* declares vars to stash the floating point config */
#line 316 "lib/Math/Geometry/Delaunay.c"
	SV *	RETVAL;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Math::Geometry::Delaunay::TriangulateioPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    arg1 = INT2PTR(Math__Geometry__Delaunay__TriangulateioPtr,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Math::Geometry::Delaunay::_triangulate",
			"arg1", "Math::Geometry::Delaunay::TriangulateioPtr",
			refstr, ST(1)
		);
	}
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Math::Geometry::Delaunay::TriangulateioPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    arg2 = INT2PTR(Math__Geometry__Delaunay__TriangulateioPtr,tmp);
	}
	else {
		const char* refstr = SvROK(ST(2)) ? "" : SvOK(ST(2)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Math::Geometry::Delaunay::_triangulate",
			"arg2", "Math::Geometry::Delaunay::TriangulateioPtr",
			refstr, ST(2)
		);
	}
;

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "Math::Geometry::Delaunay::TriangulateioPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    arg3 = INT2PTR(Math__Geometry__Delaunay__TriangulateioPtr,tmp);
	}
	else {
		const char* refstr = SvROK(ST(3)) ? "" : SvOK(ST(3)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Math::Geometry::Delaunay::_triangulate",
			"arg3", "Math::Geometry::Delaunay::TriangulateioPtr",
			refstr, ST(3)
		);
	}
;
#line 146 "lib/Math/Geometry/Delaunay.xs"
      doVoronoi = strchr(arg0, 'v');
      /* set normal double precision mode (triangle usually does this too) */
      XPFPA_SWITCH_DOUBLE()
      triangulate(arg0,arg1,arg2,arg3);
      /* set the floating point config back to whatever it was */
      XPFPA_RESTORE()

      /* Triangle just copies pointers from IN to OUT for these two lists of redundant info. */
      /* To enable safe garbage collection/DESTROY, we make a copy of the data for OUT.      */

      if (arg1->numberofholes   && arg1->holelist  ) {
          Newx(arg2->holelist, arg1->numberofholes   *  2, double);
          Copy(arg1->holelist, arg2->holelist , arg1->numberofholes   *  2, double);
          if (doVoronoi) {
              Newx(arg3->holelist, arg1->numberofholes   *  2, double);
              Copy(arg1->holelist, arg3->holelist , arg1->numberofholes   * 2, double);
              }
          }
      if (arg1->numberofregions && arg1->regionlist) {
          Newx(arg2->regionlist, arg1->numberofregions * (2 + arg1->numberoftriangleattributes), double);
          Copy(arg1->regionlist, arg2->regionlist , arg1->numberofregions * (2 + arg1->numberoftriangleattributes), double);
          if (doVoronoi) {
              Newx(arg3->regionlist, arg1->numberofregions * (2 + arg1->numberoftriangleattributes), double);
              Copy(arg1->regionlist, arg3->regionlist , arg1->numberofregions * (2 + arg1->numberoftriangleattributes), double);
              }
          }
#line 387 "lib/Math/Geometry/Delaunay.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Geometry__Delaunay__counterclockwise); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Geometry__Delaunay__counterclockwise)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "pax, pay, pbx, pby, pcx, pcy");
    {
#line 176 "lib/Math/Geometry/Delaunay.xs"
        double pa[2];
        double pb[2];
        double pc[2];
#line 404 "lib/Math/Geometry/Delaunay.c"
	double	RETVAL;
	dXSTARG;
	double	pax = (double)SvNV(ST(0))
;
	double	pay = (double)SvNV(ST(1))
;
	double	pbx = (double)SvNV(ST(2))
;
	double	pby = (double)SvNV(ST(3))
;
	double	pcx = (double)SvNV(ST(4))
;
	double	pcy = (double)SvNV(ST(5))
;
#line 180 "lib/Math/Geometry/Delaunay.xs"
        pa[0] = pax; pa[1] = pay;
        pb[0] = pbx; pb[1] = pby;
        pc[0] = pcx; pc[1] = pcy;
        RETVAL = mgdcounterclockwise(pa, pb, pc);
#line 424 "lib/Math/Geometry/Delaunay.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	Math__Geometry__Delaunay__Triangulateio	RETVAL;
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
#line 193 "lib/Math/Geometry/Delaunay.xs"
        Zero((void*)&RETVAL, sizeof(RETVAL), char);
        /* initialize everything in the struct */
        RETVAL.pointlist                  = (double *) NULL;     /* In / out */
        RETVAL.pointattributelist         = (double *) NULL;     /* In / out */
        RETVAL.pointmarkerlist            = (int *)    NULL;     /* In / out */
        RETVAL.numberofpoints             = (int)         0;     /* In / out */
        RETVAL.numberofpointattributes    = (int)         0;     /* In / out */

        RETVAL.trianglelist               = (int *)    NULL;     /* In / out */
        RETVAL.triangleattributelist      = (double *) NULL;     /* In / out */
        RETVAL.trianglearealist           = (double *) NULL;     /* In only */
        RETVAL.neighborlist               = (int *)    NULL;     /* Out only */
        RETVAL.numberoftriangles          = (int)         0;     /* In / out */
        RETVAL.numberofcorners            = (int)         3;     /* In / out */
        RETVAL.numberoftriangleattributes = (int)         0;     /* In / out */

        RETVAL.segmentlist                = (int *)    NULL;     /* In / out */
        RETVAL.segmentmarkerlist          = (int *)    NULL;     /* In / out */
        RETVAL.numberofsegments           = (int)         0;     /* In / out */

        RETVAL.holelist                   = (double *) NULL;     /* In / pointer to array copied out */
        RETVAL.numberofholes              = (int)         0;     /* In / copied out */

        RETVAL.regionlist                 = (double *) NULL;     /* In / pointer to array copied out */
        RETVAL.numberofregions            = (int)         0;     /* In / copied out */

        RETVAL.edgelist                   = (int *)    NULL;     /* Out only */
        RETVAL.edgemarkerlist             = (int *)    NULL;     /* Not used with Voronoi diagram; out only */
        RETVAL.normlist                   = (double *) NULL;     /* Used only with Voronoi diagram; out only */
        RETVAL.numberofedges              = (int)         0;     /* Out only */
#line 473 "lib/Math/Geometry/Delaunay.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pvn(RETVALSV, "Math::Geometry::Delaunay::Triangulateio", (char *)&RETVAL, sizeof(RETVAL));
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_numberof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_numberof)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, newval= 0");
    {
#line 243 "lib/Math/Geometry/Delaunay.xs"
        struct triangulateio * p;
        STRLEN len;
#line 496 "lib/Math/Geometry/Delaunay.c"
	int	RETVAL;
	dXSTARG;
	SV *	THIS = ST(0)
;
	int	newval;

	if (items < 2)
	    newval = 0;
	else {
	    newval = (int)SvIV(ST(1))
;
	}
#line 246 "lib/Math/Geometry/Delaunay.xs"
        if (!sv_derived_from(THIS, "Math::Geometry::Delaunay::Triangulateio")) {croak("Wrong type to numberof()");} 
        if (SvCUR(SvRV(THIS)) != sizeof(*p)) { croak("Size %lu of packed data != expected %lu", SvCUR(SvRV(THIS)), sizeof(*p)); }
        p = (struct triangulateio *) SvPV((SV*)SvRV(THIS), len);

        switch (ix) {
            case 1 : if ( items > 1 ) {p->numberofpoints             = newval;} RETVAL = p->numberofpoints; break;
            case 2 : if ( items > 1 ) {p->numberofpointattributes    = newval;} RETVAL = p->numberofpointattributes; break;
            case 3 : if ( items > 1 ) {p->numberoftriangles          = newval;} RETVAL = p->numberoftriangles; break;
            case 4 : if ( items > 1 ) {p->numberofcorners            = newval;} RETVAL = p->numberofcorners; break;
            case 5 : if ( items > 1 ) {p->numberoftriangleattributes = newval;} RETVAL = p->numberoftriangleattributes; break;
            case 6 : if ( items > 1 ) {p->numberofsegments           = newval;} RETVAL = p->numberofsegments; break;
            case 7 : if ( items > 1 ) {p->numberofholes              = newval;} RETVAL = p->numberofholes; break;
            case 8 : if ( items > 1 ) {p->numberofregions            = newval;} RETVAL = p->numberofregions; break;
            case 9 : if ( items > 1 ) {p->numberofedges              = newval;} RETVAL = p->numberofedges; break;
            default : RETVAL = 0;
            }
#line 526 "lib/Math/Geometry/Delaunay.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_doubleList); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_doubleList)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "array, ...");
    {
#line 296 "lib/Math/Geometry/Delaunay.xs"
        IV size_RETVAL;
        struct triangulateio * p;
        STRLEN len;
        int orig_items_cnt = (int) items;
#line 547 "lib/Math/Geometry/Delaunay.c"
	doubleArray *	RETVAL;
	doubleArray *	array;

    /**************************************************************************/
    /* Modified TYPEMAP INPUT FOR T_ARRAY                                     */
    /* This always skips the first item on the stack, ST(0), which is our     */
    /* object reference. This allows the array getter/setter to be called     */
    /* like obj->getset().                                                    */
    /* Array members are read as doubles, then cast to the type set up in a   */
    /* define like this:                                                      */
    /* #define intArrayPtrContains int                                        */
    /* So it should work with doubles and the largest ints that fit in your   */
    /* doubles. The largest int that fits in a double is then the limit for   */
    /* the number of points or edges in a triangulation.                      */
    /**************************************************************************/
    IV ix_array = 0 + 1;
    items--;
    if (items>0) {
        array = doubleArrayPtr(items - 0 + 1);
        while (items--) {
            /*
            	array[ix_array - 0] = (double)SvNV(ST(ix_array))
;
            */

            array[ix_array - 0 - 1] = (doubleArrayPtrContains)SvNV(ST(ix_array));
            ix_array++;
        }
    }
    /* this is the number of elements in the array */
    ix_array -= (0 + 1)
;
#line 301 "lib/Math/Geometry/Delaunay.xs"
        if (!sv_derived_from(ST(0), "Math::Geometry::Delaunay::Triangulateio")) {croak("Wrong type to numberof()");} 
        if (SvCUR(SvRV(ST(0))) != sizeof(*p)) { croak("Size %lu of packed data != expected %lu", SvCUR(SvRV(ST(0))), sizeof(*p)); }
        p = (struct triangulateio *) SvPV((SV*)SvRV(ST(0)), len);

        /* setter */
        if (orig_items_cnt > 1) {
          switch (ix) {
              case 1 :  if (p->pointlist)             {trifree(p->pointlist);}             p->pointlist             = array ; p->numberofpoints  = ix_array/2; break;
              case 2 :  if (p->pointattributelist)    {trifree(p->pointattributelist);}    p->pointattributelist    = array ; break;
              case 3 :  if (p->triangleattributelist) {trifree(p->triangleattributelist);} p->triangleattributelist = array ; break;
              case 4 :  if (p->trianglearealist)      {trifree(p->trianglearealist);}      p->trianglearealist      = array ; break;
              case 5 :  if (p->holelist)              {trifree(p->holelist);}              p->holelist              = array ; p->numberofholes   = ix_array/2; break;
              case 6 :  if (p->regionlist)            {trifree(p->regionlist);}            p->regionlist            = array ; p->numberofregions = ix_array/2; break;
              case 7 :  if (p->normlist)              {trifree(p->normlist);}              p->normlist              = array ; break;
              }
          /* return count of how many items added */
          ST(0) = sv_newmortal();
          sv_setnv(ST(0), (double) ix_array);
          XSRETURN(1);
          }
        /* getter */
        else {
          switch (ix) {
              case 1 : RETVAL = p->pointlist;             size_RETVAL = p->numberofpoints*2; break;
              case 2 : RETVAL = p->pointattributelist;    size_RETVAL = p->numberofpoints*p->numberofpointattributes; break;
              case 3 : RETVAL = p->triangleattributelist; size_RETVAL = p->numberoftriangles*p->numberoftriangleattributes; break;
              case 4 : RETVAL = p->trianglearealist;      size_RETVAL = p->numberoftriangles; break;
              case 5 : RETVAL = p->holelist;              size_RETVAL = p->numberofholes*2; break;
              case 6 : RETVAL = p->regionlist;            size_RETVAL = p->numberofregions*p->numberoftriangleattributes; break;
              case 7 : RETVAL = p->normlist;              size_RETVAL = p->numberofedges*2; break;
              default: RETVAL = (double *) NULL;          size_RETVAL = 0;
              }
          }
#line 614 "lib/Math/Geometry/Delaunay.c"
        {
	    U32 ix_RETVAL;
            SSize_t extend_size =
                /* The weird way this is written is because g++ is dumb
                 * enough to warn "comparison is always false" on something
                 * like:
                 *
                 * sizeof(a) > sizeof(b) && a > B_t_MAX
                 *
                 * (where the LH condition is false)
                 */
                (size_RETVAL > (sizeof(size_RETVAL) > sizeof(SSize_t)
                              ? SSize_t_MAX : size_RETVAL))
                ? -1 : (SSize_t)size_RETVAL;
	    EXTEND(SP, extend_size);
	    for (ix_RETVAL = 0; ix_RETVAL < size_RETVAL; ix_RETVAL++) {
		ST(ix_RETVAL) = sv_newmortal();
		sv_setnv(ST(ix_RETVAL), (double)RETVAL[ix_RETVAL]);
	    }
        }
#line 337 "lib/Math/Geometry/Delaunay.xs"
        XSRETURN(size_RETVAL);
#line 637 "lib/Math/Geometry/Delaunay.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_intList); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_intList)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "array, ...");
    {
#line 352 "lib/Math/Geometry/Delaunay.xs"
        IV size_RETVAL;
        struct triangulateio * p;
        STRLEN len;
        int orig_items_cnt = (int) items;
#line 656 "lib/Math/Geometry/Delaunay.c"
	intArray *	RETVAL;
	intArray *	array;

    /**************************************************************************/
    /* Modified TYPEMAP INPUT FOR T_ARRAY                                     */
    /* This always skips the first item on the stack, ST(0), which is our     */
    /* object reference. This allows the array getter/setter to be called     */
    /* like obj->getset().                                                    */
    /* Array members are read as doubles, then cast to the type set up in a   */
    /* define like this:                                                      */
    /* #define intArrayPtrContains int                                        */
    /* So it should work with doubles and the largest ints that fit in your   */
    /* doubles. The largest int that fits in a double is then the limit for   */
    /* the number of points or edges in a triangulation.                      */
    /**************************************************************************/
    IV ix_array = 0 + 1;
    items--;
    if (items>0) {
        array = intArrayPtr(items - 0 + 1);
        while (items--) {
            /*
            	array[ix_array - 0] = (int)SvIV(ST(ix_array))
;
            */

            array[ix_array - 0 - 1] = (intArrayPtrContains)SvNV(ST(ix_array));
            ix_array++;
        }
    }
    /* this is the number of elements in the array */
    ix_array -= (0 + 1)
;
#line 357 "lib/Math/Geometry/Delaunay.xs"
        if (!sv_derived_from(ST(0), "Math::Geometry::Delaunay::Triangulateio")) {croak("Wrong type to numberof()");} 
        if (SvCUR(SvRV(ST(0))) != sizeof(*p)) { croak("Size %lu of packed data != expected %lu", SvCUR(SvRV(ST(0))), sizeof(*p)); }
        p = (struct triangulateio *) SvPV((SV*)SvRV(ST(0)), len);
        /* setter */
        if (orig_items_cnt > 1) {
            switch (ix) {
                case 1 :  if (p->pointmarkerlist)   {trifree(p->pointmarkerlist);}   p->pointmarkerlist = array;   break;
                case 2 :  if (p->trianglelist)      {trifree(p->trianglelist);}      p->trianglelist = array;      p->numberoftriangles = ix_array/3; break;
                case 3 :  if (p->neighborlist)      {trifree(p->neighborlist);}      p->neighborlist = array;      break;
                case 4 :  if (p->segmentlist)       {trifree(p->segmentlist);}       p->segmentlist = array;       p->numberofsegments  = ix_array/2; break;
                case 5 :  if (p->segmentmarkerlist) {trifree(p->segmentmarkerlist);} p->segmentmarkerlist = array; break;
                case 6 :  if (p->edgelist)          {trifree(p->edgelist);}          p->edgelist = array;          p->numberofedges     = ix_array/2; break;
                case 7 :  if (p->edgemarkerlist)    {trifree(p->edgemarkerlist);}    p->edgemarkerlist = array;    break;
                }
            /* return count of how many items added */
            ST(0) = sv_newmortal();
            sv_setiv(ST(0), ix_array);
            XSRETURN(1);
            }
        /* getter */
        else {
            switch (ix) {
                case 1 : RETVAL = p->pointmarkerlist;   size_RETVAL = p->pointmarkerlist   ? p->numberofpoints      : 0; break;
                case 2 : RETVAL = p->trianglelist;      size_RETVAL = p->trianglelist      ? p->numberoftriangles * p->numberofcorners : 0; break;
                case 3 : RETVAL = p->neighborlist;      size_RETVAL = p->neighborlist      ? p->numberoftriangles*3 : 0; break;
                case 4 : RETVAL = p->segmentlist;       size_RETVAL = p->segmentlist       ? p->numberofsegments*2  : 0; break;
                case 5 : RETVAL = p->segmentmarkerlist; size_RETVAL = p->segmentmarkerlist ? p->numberofsegments    : 0; break;
                case 6 : RETVAL = p->edgelist;          size_RETVAL = p->edgelist          ? p->numberofedges*2     : 0; break;
                case 7 : RETVAL = p->edgemarkerlist;    size_RETVAL = p->edgemarkerlist    ? p->numberofedges       : 0; break;
                default: RETVAL = (int *) NULL;         size_RETVAL = 0;
                }
            }
#line 722 "lib/Math/Geometry/Delaunay.c"
        {
	    U32 ix_RETVAL;
            SSize_t extend_size =
                /* The weird way this is written is because g++ is dumb
                 * enough to warn "comparison is always false" on something
                 * like:
                 *
                 * sizeof(a) > sizeof(b) && a > B_t_MAX
                 *
                 * (where the LH condition is false)
                 */
                (size_RETVAL > (sizeof(size_RETVAL) > sizeof(SSize_t)
                              ? SSize_t_MAX : size_RETVAL))
                ? -1 : (SSize_t)size_RETVAL;
	    EXTEND(SP, extend_size);
	    for (ix_RETVAL = 0; ix_RETVAL < size_RETVAL; ix_RETVAL++) {
		ST(ix_RETVAL) = sv_newmortal();
		sv_setiv(ST(ix_RETVAL), (IV)RETVAL[ix_RETVAL]);
	    }
        }
#line 392 "lib/Math/Geometry/Delaunay.xs"
        XSRETURN(size_RETVAL);
#line 745 "lib/Math/Geometry/Delaunay.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_to_ptr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_to_ptr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
#line 397 "lib/Math/Geometry/Delaunay.xs"
        STRLEN len;
#line 760 "lib/Math/Geometry/Delaunay.c"
	Math__Geometry__Delaunay__TriangulateioPtr	RETVAL;
	SV *	THIS = ST(0)
;
#line 399 "lib/Math/Geometry/Delaunay.xs"
        RETVAL = (struct triangulateio *) SvPV((SV*)SvRV(THIS), len);
#line 766 "lib/Math/Geometry/Delaunay.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Math::Geometry::Delaunay::TriangulateioPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Geometry__Delaunay__Triangulateio_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
#line 406 "lib/Math/Geometry/Delaunay.xs"
        STRLEN len;
        struct triangulateio * p;
#line 788 "lib/Math/Geometry/Delaunay.c"
	SV *	RETVAL;
	SV *	THIS = ST(0)
;
#line 409 "lib/Math/Geometry/Delaunay.xs"
        if (!sv_derived_from(ST(0), "Math::Geometry::Delaunay::Triangulateio")) {croak("Wrong type to numberof()");} 
        if (SvCUR(SvRV(ST(0))) != sizeof(*p)) { croak("Size %lu of packed data != expected %lu", SvCUR(SvRV(ST(0))), sizeof(*p)); }
        p = (struct triangulateio *) SvPV((SV*)SvRV(ST(0)), len);

        if (p->pointlist)             {trifree(p->pointlist);}
        if (p->pointattributelist)    {trifree(p->pointattributelist);}
        if (p->pointmarkerlist)       {trifree(p->pointmarkerlist);}
        if (p->trianglelist)          {trifree(p->trianglelist);}
        if (p->triangleattributelist) {trifree(p->triangleattributelist);}
        if (p->trianglearealist)      {trifree(p->trianglearealist);}
        if (p->neighborlist)          {trifree(p->neighborlist);}
        if (p->segmentlist)           {trifree(p->segmentlist);}
        if (p->segmentmarkerlist)     {trifree(p->segmentmarkerlist);}
        if (p->holelist)              {trifree(p->holelist);}
        if (p->regionlist)            {trifree(p->regionlist);}
        if (p->edgelist)              {trifree(p->edgelist);}
        if (p->edgemarkerlist)        {trifree(p->edgemarkerlist);}
        if (p->normlist)              {trifree(p->normlist);}
#line 811 "lib/Math/Geometry/Delaunay.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Math__Geometry__Delaunay); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Geometry__Delaunay)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::Geometry::Delaunay::exactinit", XS_Math__Geometry__Delaunay_exactinit);
        newXS_deffile("Math::Geometry::Delaunay::_triangulate", XS_Math__Geometry__Delaunay__triangulate);
        newXS_deffile("Math::Geometry::Delaunay::_counterclockwise", XS_Math__Geometry__Delaunay__counterclockwise);
        newXS_deffile("Math::Geometry::Delaunay::Triangulateio::new", XS_Math__Geometry__Delaunay__Triangulateio_new);
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberof", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberofcorners", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberofedges", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 9;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberofholes", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberofpointattributes", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberofpoints", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberofregions", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 8;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberofsegments", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberoftriangleattributes", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::numberoftriangles", XS_Math__Geometry__Delaunay__Triangulateio_numberof);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::doubleList", XS_Math__Geometry__Delaunay__Triangulateio_doubleList);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::holelist", XS_Math__Geometry__Delaunay__Triangulateio_doubleList);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::normlist", XS_Math__Geometry__Delaunay__Triangulateio_doubleList);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::pointattributelist", XS_Math__Geometry__Delaunay__Triangulateio_doubleList);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::pointlist", XS_Math__Geometry__Delaunay__Triangulateio_doubleList);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::regionlist", XS_Math__Geometry__Delaunay__Triangulateio_doubleList);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::trianglearealist", XS_Math__Geometry__Delaunay__Triangulateio_doubleList);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::triangleattributelist", XS_Math__Geometry__Delaunay__Triangulateio_doubleList);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::edgelist", XS_Math__Geometry__Delaunay__Triangulateio_intList);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::edgemarkerlist", XS_Math__Geometry__Delaunay__Triangulateio_intList);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::intList", XS_Math__Geometry__Delaunay__Triangulateio_intList);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::neighborlist", XS_Math__Geometry__Delaunay__Triangulateio_intList);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::pointmarkerlist", XS_Math__Geometry__Delaunay__Triangulateio_intList);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::segmentlist", XS_Math__Geometry__Delaunay__Triangulateio_intList);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::segmentmarkerlist", XS_Math__Geometry__Delaunay__Triangulateio_intList);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("Math::Geometry::Delaunay::Triangulateio::trianglelist", XS_Math__Geometry__Delaunay__Triangulateio_intList);
        XSANY.any_i32 = 2;
        newXS_deffile("Math::Geometry::Delaunay::Triangulateio::to_ptr", XS_Math__Geometry__Delaunay__Triangulateio_to_ptr);
        newXS_deffile("Math::Geometry::Delaunay::Triangulateio::DESTROY", XS_Math__Geometry__Delaunay__Triangulateio_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
